/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */

struct NotifyPort {
	struct Node np_Node;
	struct MsgPort *np_Port;
};

extern char User[][USERLEN+1];
extern struct List Mailboxes[];
extern struct List NotifyPortList[];
extern struct Strings Strings[];

extern FILE *yyin;

struct Strings {
	char **HeaderStrings;
	int NumberOfStrings;
	int StringsAllocated;
};



/*
 *  addmail.c 
 */

struct Mail *AddMail(int i,ULONG Number); /* not reentrant (->flex/bison parser) */


/*
 *  headerstrings.c
 */

int ReadStrings(BPTR File,struct Strings *);
int WriteStrings(BPTR File,struct Strings *);
void FreeStrings(struct Strings *);
char *GetString(int Number,struct Strings *);
int GetNumber(char *s,int doinsert,struct Strings *);


/* 
 *  msgid.c 
 */

char *GetNewMsgId(char *);  /* reentrant */


/*
 *  notify.c
 */

/* not reentrant (list not locked) */
void Notify(int User,int Event,int Number,struct Mail *Mail); 


/*
 *  readcontents.c 
 */

int ReadContents(char *username,struct List *Mailbox,struct Strings *Strings); /* reentrant */


/* 
 *  writecontents.c 
 */

/* _not_ reentrant */
int WriteContents(char *username,struct List *Mailbox,struct Strings *Strings);


